LoadPackage("atlasrep");

groupname := "(3xG2(3)):2";
subgroup := "3xG2(3)";

LogTo("step4.log");

Print("Fusion of conjugacy classes from ", subgroup, " into ", groupname, "\n");

ct1 := CharacterTable(groupname);
ct2 := CharacterTable(CyclicGroup(3))*CharacterTable("G2(3)");

fus := FusionConjugacyClasses(ct2, ct1);
if not fus = fail then
  for t in [1..Size(fus)] do
    Print(ClassNames(ct2)[t], " --> ", ClassNames(ct1)[fus[t]], "\n");
  od;
else
  for fus in PossibleClassFusions(ct2, ct1) do
    for t in [1..Size(fus)] do
      Print(ClassNames(ct2)[t], " --> ", ClassNames(ct1)[fus[t]], ";\n");
    od;
    Print("--\n");
  od;
fi;

    
 
