### In this example we show how to recover the data saved
### in the .rec file. 

LoadPackage("atlasrep");

### The format for classinfo is [ r, s, order, comment ]
data := rec(
  base := [ 1, 2, 3, 4 ],
  group := "M11",
  comments := "Maximal subgroups",
  classinfo := [
    [ [ 1, 4, 5, 2 ], [ 4, 10, 7, 1 ], 2, "D" ],
    [ [ 1, 3, 6, 7 ], [ 2, 3, 10, 5 ], 4, "D" ],
    [ [ 2, 3, 6, 4 ], [ 10, 1, 6, 7 ], 5, "D" ],
    [ [ 2, 5, 11, 8 ], [ 4, 7, 11, 3 ], 6, "D" ],
    [ [ 1, 3, 11, 10 ], [ 11, 3, 4, 2 ], 3, "D" ],
    [ fail, (), 1, "one"]
  ]
);

### M11 was defined in this way
gr := AtlasGroup("M11"); 
bg := data.base;

### We check the conjugacy class of involutions
r := RepresentativeAction(gr, bg, data.classinfo[1][1], OnTuples);
s := RepresentativeAction(gr, bg, data.classinfo[1][2], OnTuples);

sg := Group(r,s);

Print("The conjugacy class 2A of M11\n");
Print("=============================\n");
Print("r=", r, "\n");
Print("s=", s, "\n");
Print("(rs)^2 = (sr)^2? ", (r*s)^2 = (s*r)^2, "\n");
Print("<r,s> is isomprhic to ", StructureDescription(sg),"\n");
Print("Are r and s are conjugate in <r,s>? ", IsConjugate(sg, r, s), "\n");


